#include <windows.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <io.h>

typedef struct STEXTPOStag{
	int	 x;
	int	 y;
	int	 width;
	int	 height;
	char text[500];
}STEXTPOS;

#pragma comment( lib, "../lib/i2pocrsdk.lib" )

__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_GetTextInfo(char *lpszPDFFile, LPBYTE *lpChars, char *lpszOptions);
__declspec(dllexport) void   WINAPI Image2PDFOCR_SinglePage_FreeTextInfo(LPBYTE lpChars);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SinglePage_CreatePDF(char *lpszInPDFFile, LPBYTE lpChars, int nCharCount, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_PDFCmd(char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreateSearchablePDF(const char *lpTIFOrPDFFile, const char *lpOutputFile, const char *lpOptions);

__declspec(dllexport) HANDLE WINAPI Image2PDFOCR_GetTextHandle(char *lpszTIFOrPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetOCRedPageCount(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE *lpOutTextInfo);
__declspec(dllexport) int    WINAPI Image2PDFOCR_SetTextInfo(HANDLE hImage2PDFData, int nPage, LPBYTE lpInTextInfo, int nCharNum);
__declspec(dllexport) void   WINAPI Image2PDFOCR_FreeTextHandle(HANDLE hImage2PDFData);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDF(HANDLE hImage2PDFData, char *lpszOutPDFFile, char *lpszOptions);
__declspec(dllexport) int    WINAPI Image2PDFOCR_CreatePDFInMemory(HANDLE hImage2PDFData, char *lpszOptions, LPBYTE *lpDataBuf, int *nDataBufLen);
__declspec(dllexport) int    WINAPI Image2PDFOCR_GetPageCount(char *lpszPDFFile);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordCountOnPage(HANDLE hImage2PDFData, int nPage);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_GetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int *X, int *Y, int *Width, int *Height, char *lpText);
__declspec(dllexport) int	 WINAPI Image2PDFOCR_SetWordInfoByIndex(HANDLE hImage2PDFData, int nPage, int nWordIndex, int X, int Y, int Width, int Height, char *lpText);

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

int main()
{
	int nRet = 0;
	//Example #1, Convert TIFF file to searchable PDF file directly
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test.tif");
		GetModulePath(szOutFile,"test_tif_ocred.pdf");
		nRet = Image2PDFOCR_CreateSearchablePDF(szInFile, szOutFile, "");
		printf("Example #1 return '%d'\n", nRet);
	}
	//Example #2, Create single page searchable PDF file, these functions are useful for single page PDF files
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test2.pdf");
		GetModulePath(szOutFile,"test2_pdf_ocred-singlepage.pdf");

		LPBYTE lpChars = NULL;
		int nCharCount = Image2PDFOCR_SinglePage_GetTextInfo(szInFile, &lpChars, "-pidpi 300 -firstpg 1 -lastpg 1");
		STEXTPOS *lpTextPos = (STEXTPOS*)lpChars;
		for(int i = 0; i < nCharCount; i++)
		{
			printf("%d,%d,%d,%d,%s\n", lpTextPos[i].x, lpTextPos[i].y, lpTextPos[i].width, lpTextPos[i].height, lpTextPos[i].text);
		}
		nRet = Image2PDFOCR_SinglePage_CreatePDF(szInFile, lpChars, nCharCount, szOutFile, "-pidpi 300 -firstpg 1 -lastpg 1");
		Image2PDFOCR_SinglePage_FreeTextInfo(lpChars);
		printf("Example #2 return '%d'\n", nRet);
	}

	//Example #3: Get Text Information first, you can modify OCRed text result, and create searchable PDF file again
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test2.pdf");
		GetModulePath(szOutFile,"test2_pdf_ocred-by-handle.pdf");

		int nPageCount = Image2PDFOCR_GetPageCount(szInFile);
		printf("'%s' file contains '%d' pages.\n", szInFile, nPageCount);
		HANDLE hOCRTextSDK = Image2PDFOCR_GetTextHandle(szInFile, "-pidpi 300");
		if(hOCRTextSDK)
		{
			int nPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
			for(int page = 0; page < nPageCount; page++)
			{
				LPBYTE lpChars = NULL;
				int nCharCount = Image2PDFOCR_GetTextInfo(hOCRTextSDK, page, &lpChars);
				STEXTPOS *lpTextPos = (STEXTPOS*)lpChars;
				for(int i = 0; i < nCharCount; i++)
				{
					printf("%d,%d,%d,%d,%s\n", lpTextPos[i].x, lpTextPos[i].y, lpTextPos[i].width, lpTextPos[i].height, lpTextPos[i].text);
				}
				//modify OCRed text contents
				if(lpTextPos)
				{
					strcpy(lpTextPos->text, "VeryPDF");
				}
				Image2PDFOCR_SetTextInfo(hOCRTextSDK, page, lpChars, nCharCount);
			}
			nRet = Image2PDFOCR_CreatePDF(hOCRTextSDK, szOutFile, "-pidpi 300");
			Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
		}
		printf("Example #3 return '%d'\n", nRet);
	}

	//Example #4: Create searchable PDF file with region
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test2.pdf");
		GetModulePath(szOutFile,"test2_pdf_ocred-region.pdf");

		HANDLE hOCRTextSDK = Image2PDFOCR_GetTextHandle(szInFile, "-pidpi 300 -ocrrect \"1266,1008,2241,1362\"");
		if(hOCRTextSDK)
		{
			int nPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
			for(int page = 0; page < nPageCount; page++)
			{
				LPBYTE lpChars = NULL;
				int nCharCount = Image2PDFOCR_GetTextInfo(hOCRTextSDK, page, &lpChars);
				STEXTPOS *lpTextPos = (STEXTPOS*)lpChars;
				for(int i = 0; i < nCharCount; i++)
				{
					printf("%d,%d,%d,%d,%s\n", lpTextPos[i].x, lpTextPos[i].y, lpTextPos[i].width, lpTextPos[i].height, lpTextPos[i].text);
				}
				//modify OCRed text contents
				if(lpTextPos)
				{
					strcpy(lpTextPos->text, "VeryPDF");
				}
				Image2PDFOCR_SetTextInfo(hOCRTextSDK, page, lpChars, nCharCount);
			}
			nRet = Image2PDFOCR_CreatePDF(hOCRTextSDK, szOutFile, "-pidpi 300");
			Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
		}
		printf("Example #4 return '%d'\n", nRet);
	}
	//Example #5: Create searchable PDF file in memory
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test2.pdf");
		GetModulePath(szOutFile,"test2_pdf_ocred-in-memory.pdf");
		
		int time1 = GetTickCount();
		char *lpOptions = "-pidpi 300";
		int nPageCount = Image2PDFOCR_GetPageCount(szInFile);
		printf("'%s' file contains '%d' pages.\n", szInFile, nPageCount);
		HANDLE hOCRTextSDK = Image2PDFOCR_GetTextHandle(szInFile, lpOptions);
		if(hOCRTextSDK)
		{
			int nPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
			for(int page = 0; page < nPageCount; page++)
			{
				LPBYTE lpChars = NULL;
				int nCharCount = Image2PDFOCR_GetTextInfo(hOCRTextSDK, page, &lpChars);
				STEXTPOS *lpTextPos = (STEXTPOS*)lpChars;
				for(int i = 0; i < nCharCount; i++)
				{
					printf("%d,%d,%d,%d,%s\n", lpTextPos[i].x, lpTextPos[i].y, lpTextPos[i].width, lpTextPos[i].height, lpTextPos[i].text);
				}
				//modify OCRed text contents
				if(lpTextPos)
				{
					strcpy(lpTextPos->text, "VeryPDF");
				}
				printf("Update text info for page %d\n", page+1);
				Image2PDFOCR_SetTextInfo(hOCRTextSDK, page, lpChars, nCharCount);
			}
			LPBYTE lpDataBuf = NULL;
			int nDataBufLen = 0;
			nRet = Image2PDFOCR_CreatePDFInMemory(hOCRTextSDK, lpOptions, &lpDataBuf, &nDataBufLen);
			if(lpDataBuf != NULL && nDataBufLen > 0)
			{
				FILE *file = fopen(szOutFile, "wb");
				if(file)
				{
					fwrite(lpDataBuf, 1, nDataBufLen, file);
					fclose(file);
				}
			}
			Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
		}
		int time2 = GetTickCount();
		printf("Example #5 is spend %dms (%.2fs)...\n", time2-time1, (time2-time1)/1000.0);
		printf("Example #5 return '%d'\n", nRet);
	}
	//Example #6:
	if(1)
	{
		char szInFile[MAX_PATH] = {0};
		char szOutFile[MAX_PATH] = {0};
		GetModulePath(szInFile,"test1.pdf");
		GetModulePath(szOutFile,"test1_pdf_ocred-in-memory2.pdf");
		
		int time1 = GetTickCount();
		char *lpOptions = "-pidpi 300";
		int nPageCount = Image2PDFOCR_GetPageCount(szInFile);
		printf("'%s' file contains '%d' pages.\n", szInFile, nPageCount);
		HANDLE hOCRTextSDK = Image2PDFOCR_GetTextHandle(szInFile, lpOptions);
		if(hOCRTextSDK)
		{
			int nPageCount = Image2PDFOCR_GetOCRedPageCount(hOCRTextSDK);
			for(int page = 0; page < nPageCount; page++)
			{
				int nWordCount = Image2PDFOCR_GetWordCountOnPage(hOCRTextSDK, page);
				for(int nWordIndex = 0; nWordIndex < nWordCount; nWordIndex++)
				{
					int X, Y, Width, Height;
					char szText[500] = {0};
					Image2PDFOCR_GetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, &X, &Y, &Width, &Height, szText);
					if(nWordIndex == 0)
						strcpy(szText, "VeryPDF");
					Image2PDFOCR_SetWordInfoByIndex(hOCRTextSDK, page, nWordIndex, X, Y, Width, Height, szText);
				}
			}
			LPBYTE lpDataBuf = NULL;
			int nDataBufLen = 0;
			nRet = Image2PDFOCR_CreatePDFInMemory(hOCRTextSDK, lpOptions, &lpDataBuf, &nDataBufLen);
			if(lpDataBuf != NULL && nDataBufLen > 0)
			{
				FILE *file = fopen(szOutFile, "wb");
				if(file)
				{
					fwrite(lpDataBuf, 1, nDataBufLen, file);
					fclose(file);
				}
			}
			Image2PDFOCR_FreeTextHandle(hOCRTextSDK);
		}
		int time2 = GetTickCount();
		printf("Example #6 is spend %dms (%.2fs)...\n", time2-time1, (time2-time1)/1000.0);
		printf("Example #6 return '%d'\n", nRet);
	}
/*
	char szMergePDFCmd[1024] = {0};
	sprintf(szMergePDFCmd, "-mergepdf C:\\allfiles.txt C:\\out.pdf");
	nRet = Image2PDFOCR_PDFCmd(szMergePDFCmd);
*/
	return nRet;
}